<?php

require_once( "run-config.php" );
include_once('data.php');

$action = isset($_REQUEST['action']) ? sanitize_text_field($_REQUEST['action']) : '';

if($action == "get") {
	dia_getResults();	
} else if($action == "save") {
	dia_getSave();	
} else if($action == "delete") {
	dia_getDelete();
}

//*************** Save ***************
function dia_getSave() {
	$imgID = isset($_REQUEST['imgid']) ? sanitize_text_field($_REQUEST['imgid']) : '';	
	$postID = isset($_REQUEST['postid']) ? sanitize_text_field($_REQUEST['postid']) : 0;	
	
	//get data from jQuery
	$data = array(
		sanitize_text_field($_GET["top"]),
		sanitize_text_field($_GET["left"]),
		sanitize_text_field($_GET["width"]),
		sanitize_text_field($_GET["height"]),
		sanitize_text_field($_GET["text"]),
		sanitize_text_field($_GET["id"]),
		sanitize_text_field($_GET["noteID"]),
		sanitize_text_field($_GET["author"]),
		sanitize_email($_GET["email"]),
	);	
	
	global $wpdb;
	if($data[5] != "new") {
		//find the old image note from comment
		$result = $wpdb->get_results( $wpdb->prepare("SELECT * from ".DIA_TABLE_NOTES." WHERE note_img_ID = %s AND note_ID = %s", $imgID, $data[5]));
		foreach ($result as $commentresult) {
			$comment_id = (int)$commentresult->note_comment_ID; //comment ID
			$comment_author = $commentresult->note_author; //comment Author
			$comment_email = $commentresult->note_email; //comment Email
		};
		
		//update comment
		if( (get_option('demon_image_annotation_comments') == '0') ) {
			$wpdb->update(
				DIA_TABLE_COMMENTS,
				array( 
					'comment_content' => $data[4]
				),
				array(
					'comment_ID' => $comment_id
				)
			);
		}
		
		//update image note
		$wpdb->update(
			DIA_TABLE_NOTES,
			array( 
				'note_top' => $data[0],
				'note_left' => $data[1],
				'note_width' => $data[2],
				'note_height' => $data[3],
				'note_text' => $data[4],
				'note_text_ID' => "id_".md5($data[4]),
			),
			array(
				'note_ID' =>  $data[6]
			)
		);
		
	} else {
		//if image note is new
		$comment_post_ID = $postID;		
		$comment_author       = ( isset($_GET['author']) )  ? trim(strip_tags($_GET['author'])) : null;
		$comment_author_email = ( isset($_GET['email']) )   ? trim($_GET['email']) : null;
		$comment_author_url   = ( isset($_GET['url']) )     ? trim($_GET['url']) : null;
		$comment_content      = $data[4];
		
		//If the user is logged in, get author name and author email
		$user = wp_get_current_user();
		if ( $user->ID ) {
			if ( empty( $user->display_name ) )
				$user->display_name=$user->user_login;
				$comment_author       = $wpdb->escape($user->display_name);
				$comment_author_email = $wpdb->escape($user->user_email);
				$comment_author_url   = $wpdb->escape($user->user_url);
				if ( current_user_can('unfiltered_html') ) {
					if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_POST['_wp_unfiltered_html_comment'] ) {
						kses_remove_filters();
						kses_init_filters();
					}
				}
		}
		
		$autoapprove = 1;
		if( (get_option('demon_image_annotation_autoapprove') == '1') ) {
			$autoapprove = 0;
		}
		
		//add to comment
		if( (get_option('demon_image_annotation_comments') == '0') ) {
			$user_ID = $user->ID;
			$comment_type = '';
			$comment_parent = isset($_POST['comment_parent']) ? absint($_POST['comment_parent']) : 0;
			$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'comment_parent', 'user_ID');
			if($autoapprove == 1){
				$comment_id = wp_insert_comment($commentdata);
			}else{
				$comment_id = wp_new_comment($commentdata);	
			}
		}
		
		//add to image note
		$wpdb->insert(
			DIA_TABLE_NOTES,
			array( 
				'note_img_ID' => $imgID,
				'note_comment_ID' => $comment_id,
				'note_post_ID' => $postID,
				'note_author' => $comment_author,
				'note_email' => $comment_author_email,
				'note_top' => $data[0],
				'note_left' => $data[1],
				'note_width' => $data[2],
				'note_height' => $data[3],
				'note_text' => $data[4],
				'note_text_id' => "id_".md5($data[4]),
				'note_editable' => 1,
				'note_approved' => $autoapprove,
				'note_date' => 'now()'
			)
		);
	}	
	//output JSON array
	echo '{ "status":true, "annotation_id": "id_'.md5($data[4]).'" }';
}

//*************** Delete ***************
function dia_getDelete() {
	$qsType = isset($_REQUEST['imgid']) ? sanitize_text_field($_REQUEST['imgid']) : '';
	$data = array(
		sanitize_text_field($_GET["id"]),
	);
	
	//find the comment ID
	global $wpdb;
	$result = $wpdb->get_results( $wpdb->prepare("SELECT * from ".DIA_TABLE_NOTES." WHERE note_img_ID = %s AND note_ID = %s", $qsType, $data[0]));
	foreach ($result as $commentresult) {
		$comment_id = (int)$commentresult->note_comment_ID; //comment ID
	};
	
	//delete note from comment
	$wpdb->delete( DIA_TABLE_COMMENTS, array( 'comment_ID' => $comment_id ) );

	//delete note from image note
	$wpdb->delete( DIA_TABLE_NOTES, array( 'note_img_ID' => $qsType, 'note_ID' => $data[0] ) );

	//output JSON array
	echo '{ "status":true }';
}

//*************** Get ***************
function dia_getResults() {
	$qsType = isset($_REQUEST['imgid']) ? sanitize_text_field($_REQUEST['imgid']) : '';
	$qsPreview = isset($_REQUEST['preview']) ? sanitize_text_field($_REQUEST['preview']) : '';	
	
	global $wpdb;	
	if( (get_option('demon_image_annotation_comments') == '0') ) {
		$query = $wpdb->prepare("SELECT * from ".DIA_TABLE_NOTES." WHERE note_img_ID = %s AND note_comment_ID != %s", $qsType, 0);
	}else{
		$query = $wpdb->prepare("SELECT * from ".DIA_TABLE_NOTES." WHERE note_img_ID = %s AND note_comment_ID = %s", $qsType, 0);
	}
	
	$result = $wpdb->get_results($query);
	
	//output JSON array
	$json = array();
	
	foreach ($result as $row) {	
		$commentApprove;
		
		if($qsPreview == 1){
			$commentApprove = 1;
		}else if( (get_option('demon_image_annotation_comments') == '0') ) {
			//sync with approved comment
			$commentApprove = $wpdb->get_var($wpdb->prepare("SELECT comment_approved from ".DIA_TABLE_COMMENTS." WHERE comment_ID = %s", (int)$row->note_comment_ID));
			
			//empty string will use image note approved value;
			if($commentApprove == "") {
				$commentApprove = $row->note_approved;
			}
		} else {
			//not sync with approved comment
			$commentApprove = $row->note_approved;
		}
		
		if($commentApprove == 1) {
			$notetext = esc_html($row->note_text);//dia_txt2html($row->note_text);
			
			if( (get_option('demon_image_annotation_gravatar') == '0') ) {
				//display author avatar
				if(get_option('demon_image_annotation_gravatar_deafult') != '') {
					$defaultgravatar = get_bloginfo('template_url').get_option('demon_image_annotation_gravatar_deafult');
				} else {
					$defaultgravatar = '';
				}
				$author = "<div class='dia-author'>".get_avatar($row->note_email, 20, $defaultgravatar)." ".esc_html($row->note_author)."</div>";
			} else {
				$author = "<div class='dia-author'>".esc_html($row->note_author)."</div>";
			}
			$json['id'] = esc_html($row->note_ID);
			$json['top'] = esc_html($row->note_top);
			$json['left'] = esc_html($row->note_left);
			$json['width'] = esc_html($row->note_width);
			$json['height'] = esc_html($row->note_height);
			$json['text'] = $notetext;
			$json['note_id'] = esc_html($row->note_text_ID);
			$json['editable'] = true;
			$json['author'] = $author;
			$json['commentid'] = esc_html($row->note_comment_ID);
			$data[] = $json;
		}
	};
	
	echo '{ "status":true, "note": '.json_encode($data).' }';
}
?>